#include "stdio.h"
#include "mbed.h"
#include "string"
//#include "Arial12x12.h"
#include "Arial24x23.h"
//#include "Terminal6x8.h"
#include "Arial43x48_numb.h"

#include "ST7565.h"

//Serial pc(USBTX, USBRX);

ST7565 myLCD(SPI_8, 4000000, PB_5, PB_4, PB_3, PA_0, PA_1, PA_4, "myLCD", 240, 64);
// SPI 8bit, 4MHz, MOSI, MISO, SCK, CS, reset, A0, *name, sizeX, sizeY

unsigned short backgroundcolor=Black;
unsigned short foregroundcolor=White;

char orient=1;
int main()
{
    myLCD.set_orientation(orient);
    myLCD.background(backgroundcolor);    // set background to black
    myLCD.foreground(foregroundcolor);    // set chars to white

    while(1)
    {
    myLCD.cls();
    myLCD.set_font((unsigned char*) Terminal6x8,32,127,true); //variable width disabled
    myLCD.locate(0,0);
    myLCD.foreground(White);
    myLCD.printf("Some text just to see if auto carriage return works correctly\r\n");
    myLCD.foreground(LightGrey);
    myLCD.printf("Some text just to see if auto carriage return works correctly\r\n");
    myLCD.foreground(DarkGrey);
    myLCD.printf("Some text just to see if auto carriage return works correctly\r\n");
    myLCD.copy_to_lcd();
    wait(3);
    myLCD.cls();
    myLCD.foreground(White);
    myLCD.set_font((unsigned char*) Arial43x48_numb, 46, 58, false); //only numbers, variable-width disabled
    myLCD.locate(10,8);
    myLCD.printf("%d", 12345);
 //   myLCD.locate(5,10);
 //   myLCD.printf("Display Test\r\nFrank jagt im komplett verwahrlosten Taxi nachts durch die Stadt");
    myLCD.copy_to_lcd();
    wait(3);
    myLCD.cls();
    myLCD.set_font((unsigned char*) Arial24x23);
    myLCD.locate(10,10);
    myLCD.printf("Test");

    myLCD.line(0,0,myLCD.width()-1,0,foregroundcolor);
    myLCD.line(0,0,0,myLCD.height()-1,foregroundcolor);
    myLCD.line(0,0,myLCD.width()-1,myLCD.height()-1,foregroundcolor);

    myLCD.rect(10,30,50,40,foregroundcolor);
    myLCD.fillrect(60,30,100,40,LightGrey);

    myLCD.circle(150,32,30,foregroundcolor);
    myLCD.fillcircle(140,20,10,DarkGrey);

    double s;

    for (unsigned short i=0; i<myLCD.width(); i++)
        {
        s =10 * sin((long double) i / 10 );
        myLCD.pixel(i,40 + (int)s ,foregroundcolor);
        }
    myLCD.copy_to_lcd();
   wait(5);
    }
}